﻿<!-- DevExtreme library -->
<script type="text/javascript" src="~/assets/plugins/dxDataGrid/dx.all.js"></script>
<script type="text/javascript" src="~/assets/plugins/dxDataGrid/exceljs/polyfill.min.js"></script>
<script type="text/javascript" src="~/assets/plugins/dxDataGrid/exceljs/exceljs.min.js"></script>
<script type="text/javascript" src="~/assets/plugins/dxDataGrid/FileSaver/FileSaver.min.js"></script>


<script type="text/javascript">
	// console.log(data_json[0]);

	var _height_Window 	= $(window).height();
	var _height_Header 	= $('.iq-top-navbar').height();
	var _height_Title 	= $('.iq-card-header').height();
	var _height_Footer 	= $('.iq-footer').height();

	/* Config scroll table - Xoá comment để kích hoạt */
	var flag_fixed = false;
	if($(window).width() > 760){
		$('#gridContainer').height(_height_Window - _height_Header - _height_Title - _height_Footer - 76);
		flag_fixed = true;
	}else{
		$('#gridContainer').height(_height_Window);
		if($(window).width() > 375){
			flag_fixed = true;
		}else{
			flag_fixed = false;
		}
	}
    function addDays(date, days) {
      var result = new Date(date);
      result.setDate(result.getDate() + days);
      return result;
    }
	
    $('.btnXemBaoCaoRaVaoCong').click(function () {
        
        var NgayDangKyTuNgay = $('#NgayDangKyTuNgay').val();
        var TenDonVi = $('#DonVi').val();
        if (TenDonVi != '') {
            jQuery("#loading").fadeIn();
            GetBaoCaoRaVaoCongTheoDonVi(NgayDangKyTuNgay, TenDonVi).then(function (data) {
                GetBaoCaoDanhSachChuaKhaiBaoYTe(NgayDangKyTuNgay, TenDonVi).then(function (data) {
                    jQuery("#loading").fadeOut();
                }).catch(function (err) {
                    jQuery("#loading").fadeOut();
                });
            }).catch(function (err) {
                jQuery("#loading").fadeOut();
            });
        } else {
            alert("Vui lòng chọn đơn vị");
        }
    })
    

    function GetBaoCaoRaVaoCongTheoDonVi(NgayDangKyTuNgay,TenDonVi) {
        return new Promise(function (resolve, reject) {
          $.ajax({
            url: '@Url.Action("GetBaoCaoRaVaoCongTheoDonVi", "Admin")',
            type: 'POST',
            data: { NgayDangKyTuNgay: NgayDangKyTuNgay, TenDonVi: TenDonVi },
            dataType: 'json',
            success: function (data) {
                $('#TongSoLuongDK').html(data.TongSoLuongDK);
                $('#TongSoVao').html(data.TongSoVao);
                $('#Dat').html(parseInt(data.Dat) + '%');
                $('#BatDau').html(data.TBatDau);
                $('#KetThuc').html(data.TKetThuc);
                $('#ChuaKhaiBaoYTe').html(data.ChuaKhaiBaoYTe);
                $('#BinhThuong').html(data.BinhThuong);
                $('#TrieuChung').html(data.TrieuChung);
                $('#DichTe').html(data.DichTe);
                $('#XetNghiem').html(data.XetNghiem);
                $('#CachLy').html(data.CachLy);
                resolve(data);
            },
              error: function (err) {
                 reject(err);
            }
        });
      });
    }
    function GetBaoCaoDanhSachChuaKhaiBaoYTe(NgayDangKyTuNgay,TenDonVi) {
        return new Promise(function (resolve, reject) {
          $.ajax({
            url: '@Url.Action("GetBaoCaoDanhSachChuaKhaiBaoYTe", "Admin")',
            type: 'POST',
            data: { NgayDangKyTuNgay: NgayDangKyTuNgay, TenDonVi: TenDonVi },
            dataType: 'json',
              success: function (data) {
                  $("#gridContainer").dxDataGrid({
                      dataSource: data,
                      showBorders: true,
                      showRowLines: true,
                      searchPanel: {
                          visible: true,
                          highlightCaseSensitive: true
                      },
                      headerFilter: {
                          visible: true
                      },
                      paging: {
                          pageSize: 10,
                      },
                      pager: {
                          showPageSizeSelector: true,
                          allowedPageSizes: [10, 25, 50, 100],
                      },
                      columnAutoWidth: true,
                      export: {
                          enabled: true
                      },
                      onExporting(e) {
                          const workbook = new ExcelJS.Workbook();
                          const worksheet = workbook.addWorksheet('BAO_CAO_RA_VAO');
                          var borderStylePattern = { style: 'thick', color: { argb: 'FF7E7E7E' } };
                          DevExpress.excelExporter.exportDataGrid({
                              component: e.component,
                              worksheet,
                              topLeftCell: { row: 4, column: 1 },
                          }).then((cellRange) => {
                              // header
                              const headerRow = worksheet.getRow(2);
                              worksheet.mergeCells(2, 1, 2, 6);

                              headerRow.getCell(1).value = 'BÁO CÁO RA - VÀO CỔNG (' + TenDonVi + ')';
                              headerRow.getCell(1).font = { name: 'Arial', size: 14, bold : true };
                              headerRow.getCell(1).alignment = { horizontal: 'center' };

                              const headerRow1 = worksheet.getRow(3);
                              headerRow1.height = 20;
                              worksheet.mergeCells(3, 1, 3, 6);

                              headerRow1.getCell(2).value = 'NGÀY: ' + NgayDangKyTuNgay;
                              headerRow1.getCell(2).font = { name: 'Arial', size: 12, bold : true };
                              headerRow1.getCell(2).alignment = { horizontal: 'center' };

                          }).then(() => {
                              workbook.xlsx.writeBuffer().then((buffer) => {
                                  saveAs(new Blob([buffer], { type: 'application/octet-stream' }), 'BAO_CAO_RA_VAO.xlsx');
                              });
                          });
                          e.cancel = true;
                      },
                      columns:
                          [
                              {
                                  caption: "STT",
                                  dataField: "STT",
                                  alignment: "center"
                              },
                              {
                                  caption: "Họ tên",
                                  dataField: "HoTen",
                                  alignment: "center"
                              },
                              {
                                  caption: "Điện thoại",
                                  dataField: "DienThoai",
                                  alignment: "center"
                              },
                              {
                                  caption: "Năm sinh",
                                  dataField: "NamSinh",
                                  alignment: "center"
                              },
                              {
                                  caption: "Bộ phận",
                                  dataField: "TenBoPhan",
                                  alignment: "center"
                              },
                              {
                                  caption: "Trạng thái",
                                  dataField: "TrangThai",
                                  alignment: "center"
                              }
                          ],
                  });
                  resolve(data);
              },
              error: function (err) {
                  reject(err);
            }
            });
        });
    }

</script>
